VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4590
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4740
   LinkTopic       =   "Form1"
   ScaleHeight     =   4590
   ScaleWidth      =   4740
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      Height          =   3615
      Left            =   0
      ScaleHeight     =   3555
      ScaleWidth      =   4515
      TabIndex        =   2
      Top             =   360
      Width           =   4575
   End
   Begin VB.TextBox txtN 
      Height          =   285
      Left            =   240
      TabIndex        =   1
      Text            =   "5"
      Top             =   0
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "N"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' See "Swirl" by Eric W. Weisstein from MathWorld
' A Wolfram Web Resource. http://mathworld.wolfram.com/Swirl.html

Option Explicit

Private Sub Form_Load()
    picCanvas.ScaleMode = vbPixels
    picCanvas.AutoRedraw = True
End Sub

Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - picCanvas.Top
    If hgt < 120 Then hgt = 120
    picCanvas.Move 0, picCanvas.Top, ScaleWidth, hgt

    DrawSwirl
End Sub


Private Sub DrawSwirl()
Const MY_SCALE As Single = 10

Dim n As Single
Dim cx As Single
Dim cy As Single
Dim r As Single
Dim theta As Single
Dim x As Integer
Dim y As Integer
Dim dy As Single
Dim dy2 As Single
Dim dx As Single
Dim f As Single
Dim b As Integer

    On Error Resume Next
    n = CSng(txtN.Text)
    If Err.Number <> 0 Then Exit Sub
    On Error GoTo 0

    picCanvas.Cls

    cx = picCanvas.ScaleWidth / 2
    cy = picCanvas.ScaleHeight / 2
    For y = 0 To picCanvas.ScaleHeight - 1
        dy = (y - cy) / MY_SCALE
        dy2 = dy * dy
        For x = 0 To picCanvas.ScaleWidth - 1
            dx = (x - cx) / MY_SCALE
            r = Sqr(dx * dx + dy2)
            If dx = 0 And dy = 0 Then
                theta = 0
            Else
                theta = Atan2(dy, dx)
            End If
            f = Sin(6 * Cos(r) - n * theta)
            b = Int(128 + 127 * f)
            picCanvas.PSet (x, y), RGB(0, 0, b)
        Next x
    Next y
End Sub
Public Function Atan2(ByVal y As Double, ByVal x As Double) As Double
Dim theta As Double

    If (Abs(x) < 0.0000001) Then
        If (Abs(y) < 0.0000001) Then
            theta = 0#
        ElseIf (y > 0#) Then
            theta = 1.5707963267949
        Else
            theta = -1.5707963267949
        End If
    Else
        theta = Atn(y / x)

        If (x < 0) Then
            If (y >= 0#) Then
                theta = 3.14159265358979 + theta
            Else
                theta = theta - 3.14159265358979
            End If
        End If
    End If

    Atan2 = theta
End Function

Private Sub txtN_Change()
    If Len(txtN.Text) > 0 Then
        DrawSwirl
    End If
End Sub


